includes/classes/class.PlanetRessUpdate.php

Change

<?
	private function BuildingQueue() 
	{
		while($this->CheckPlanetBuildingQueue())
			$this->SetNextQueueElementOnTop();
	}
?>

to

<?
	private function BuildingQueue() 
	{
		$this->CheckPlanetBuildingsNew();
	}
?>

after add

<?
	private function CheckPlanetBuildingsNew()
	{
		global $resource, $reslist;
		if (empty($this->PLANET['b_building_id']) || $this->PLANET['b_building'] > $this->TIME)
			return false;
		$CurrentQueue	= unserialize($this->PLANET['b_building_id']);
		$b_building = 0;
		foreach($CurrentQueue as $key => $builElem)
		{
			$Element      	= $builElem[0];
			$BuildEndTime 	= $builElem[3];
			$BuildMode    	= $builElem[4];
			if ($BuildEndTime > $this->TIME){	
				if($b_building == 0)
					$b_building = $BuildEndTime;
				elseif($b_building > $BuildEndTime)
					$b_building = $BuildEndTime;
				continue;
			}
			if(!isset($this->Builded[$Element]))
				$this->Builded[$Element] = 0;
			if ($BuildMode == 'build')
			{
				$this->PLANET['field_current']		+= 1;
				$this->PLANET[$resource[$Element]]	+= 1;
				$this->Builded[$Element]			+= 1;
			}
			else
			{
				$this->PLANET['field_current'] 		-= 1;
				$this->PLANET[$resource[$Element]] 	-= 1;
				$this->Builded[$Element]			-= 1;
			}
			unset($CurrentQueue[$key]);
			$OnHash	= in_array($Element, $reslist['prod']);
			$this->UpdateResource($BuildEndTime, !$OnHash);		
		}
		if (count($CurrentQueue) == 0) {
			$this->PLANET['b_building']    	= 0;
			$this->PLANET['b_building_id'] 	= '';
​
			return false;
		} else {
			$this->PLANET['b_building']    	= $b_building;
			$this->PLANET['b_building_id'] 	= serialize($CurrentQueue);
			return true;
		}
	}
​
?>

includes/pages/game/ShowBuildingsPage.class.php

Change
<?
	private function CancelBuildingFromQueue()
	{
	...
	}
?>

to

<?
	private function CancelBuildingFromQueue($Element)
	{
		global $PLANET, $USER, $resource;
		$CurrentQueue  = unserialize($PLANET['b_building_id']);
		if (empty($CurrentQueue))
		{
			$PLANET['b_building_id']	= '';
			$PLANET['b_building']		= 0;
			return false;
		}
		$uKey = -1;
		foreach($CurrentQueue as $key => $QueueElem){
			if($Element == $QueueElem[0])
				$uKey = $key;
		}
		if($uKey == -1)
			return false;
		$Element             	= $CurrentQueue[$uKey][0];
        $BuildLevel          	= $CurrentQueue[$uKey][1];
		$BuildMode          	= $CurrentQueue[$uKey][4];
		$costResources			= BuildFunctions::getElementPrice($USER, $PLANET, $Element, $BuildMode == 'destroy', $BuildLevel);
		if(isset($costResources[901])) { $PLANET[$resource[901]]	+= $costResources[901]; }
		if(isset($costResources[902])) { $PLANET[$resource[902]]	+= $costResources[902]; }
		if(isset($costResources[903])) { $PLANET[$resource[903]]	+= $costResources[903]; }
		if(isset($costResources[921])) { $USER[$resource[921]]		+= $costResources[921]; }
		unset($CurrentQueue[$uKey]);
		if (count($CurrentQueue) == 0) {
			$PLANET['b_building']    	= 0;
			$PLANET['b_building_id'] 	= '';
		} else {
			$NewQueueArray	= array();
			$b_building = 0;
			foreach($CurrentQueue as $ListIDArray) {
				$NewQueueArray[]	= $ListIDArray;	
​
				$BuildEndTime 	= $ListIDArray[3];
				if ($BuildEndTime > TIMESTAMP){
					if($b_building == 0)
						$b_building = $BuildEndTime;
					elseif($b_building > $BuildEndTime)
						$b_building = $BuildEndTime;
				}
			}
			if(!empty($NewQueueArray)) {
				$PLANET['b_building']    	= $b_building;
				$PLANET['b_building_id'] 	= serialize($NewQueueArray);
				$this->ecoObj->setData($USER, $PLANET);
				list($USER, $PLANET)		= $this->ecoObj->getData();
			} else {
				$PLANET['b_building']    	= 0;
				$PLANET['b_building_id'] 	= '';
			}
		}
		return true;
	}
​?>

remove

<?
	private function RemoveBuildingFromQueue($QueueID)
	{
		global $USER, $PLANET;
		if ($QueueID <= 1 || empty($PLANET['b_building_id'])) {
            return false;
        }

		$CurrentQueue  = unserialize($PLANET['b_building_id']);
		$ActualCount   = count($CurrentQueue);
		if($ActualCount <= 1) {
			return $this->CancelBuildingFromQueue();
        }

        if ($QueueID - $ActualCount >= 2) {
            // Avoid race conditions
            return;
        }

        // Get ElementID from the task to cancel.
		$Element		= $CurrentQueue[$QueueID - 1][0];

		$BuildEndTime	= $CurrentQueue[$QueueID - 2][3];
		unset($CurrentQueue[$QueueID - 1]);
		$NewQueueArray	= array();
		foreach($CurrentQueue as $ID => $ListIDArray)
		{				
			if ($ID < $QueueID - 1) {
				$NewQueueArray[]	= $ListIDArray;
			} else {
				if($Element == $ListIDArray[0] || empty($ListIDArray[0]))
					continue;

				$BuildEndTime       += BuildFunctions::getBuildingTime($USER, $PLANET, $ListIDArray[0], NULL, $ListIDArray[4] == 'destroy', $ListIDArray[1]);
				$ListIDArray[3]		= $BuildEndTime;
				$NewQueueArray[]	= $ListIDArray;				
			}
		}

		if(!empty($NewQueueArray))
			$PLANET['b_building_id'] = serialize($NewQueueArray);
		else
			$PLANET['b_building_id'] = "";

        return true;
	}
​?>

Change

<?
	private function AddBuildingToQueue($Element, $AddMode = true)
	{
	...
	}
​?>

to

<?
	private function AddBuildingToQueue($Element, $AddMode = true)
	{
		global $PLANET, $USER, $resource, $reslist, $pricelist;
		if(!in_array($Element, $reslist['allow'][$PLANET['planet_type']])
			|| !BuildFunctions::isTechnologieAccessible($USER, $PLANET, $Element) 
			|| ($Element == 31 && $USER["b_tech_planet"] != 0) 
			|| (($Element == 15 || $Element == 21) && !empty($PLANET['b_hangar_id']))
			|| (!$AddMode && $PLANET[$resource[$Element]] == 0)
		)
			return;
		$CurrentQueue  		= unserialize($PLANET['b_building_id']);
​
		if (!empty($CurrentQueue)) {
			$ActualCount	= count($CurrentQueue);
		} else {
			$CurrentQueue	= array();
			$ActualCount	= 0;
		}
		$CurrentMaxFields  	= CalculateMaxPlanetFields($PLANET);
​
		$config	= Config::get();
​
		if (($AddMode && $PLANET["field_current"] >= ($CurrentMaxFields - $ActualCount)))
		{
			return;
		}
		foreach($CurrentQueue as $QueueSubArray)
		{
			if($QueueSubArray[0] == $Element)
				return;
		}
		$BuildMode 			= $AddMode ? 'build' : 'destroy';
		$BuildLevel			= $PLANET[$resource[$Element]] + (int) $AddMode;
			if($pricelist[$Element]['max'] < $BuildLevel)
				return;
​
			$costResources		= BuildFunctions::getElementPrice($USER, $PLANET, $Element, !$AddMode, $BuildLevel);
			if(!BuildFunctions::isElementBuyable($USER, $PLANET, $Element, $costResources))
				return;
			if(isset($costResources[901])) { $PLANET[$resource[901]]	-= $costResources[901]; }
			if(isset($costResources[902])) { $PLANET[$resource[902]]	-= $costResources[902]; }
			if(isset($costResources[903])) { $PLANET[$resource[903]]	-= $costResources[903]; }
			if(isset($costResources[921])) { $USER[$resource[921]]		-= $costResources[921]; }
			$elementTime    			= BuildFunctions::getBuildingTime($USER, $PLANET, $Element, $costResources);
			$BuildEndTime				= TIMESTAMP + $elementTime;
			$CurrentQueue[]				= array($Element, $BuildLevel, $elementTime, $BuildEndTime, $BuildMode);
			$PLANET['b_building_id']	= serialize($CurrentQueue);	
		$b_building = 0;
		foreach($CurrentQueue as $key => $builElem)
		{
			$Element      	= $builElem[0];
			$BuildEndTime 	= $builElem[3];
			$BuildMode    	= $builElem[4];
			if ($BuildEndTime > TIMESTAMP){
				if($b_building == 0)
					$b_building = $BuildEndTime;
				elseif($b_building > $BuildEndTime)
					$b_building = $BuildEndTime;
			}
		}
		$PLANET['b_building']		= $BuildEndTime;
	}
​?>

change

<?
	private function getQueueData()
	{
	...
	}
​?>

to

<?
	private function getQueueData()
	{
		global $LNG, $PLANET, $USER;
		$scriptData		= array();
		$quickinfo		= array();
		if ($PLANET['b_building'] == 0 || $PLANET['b_building_id'] == "")
			return array('queue' => $scriptData, 'quickinfo' => $quickinfo);
		$buildQueue		= unserialize($PLANET['b_building_id']);
		foreach($buildQueue as $BuildArray) {
			if ($BuildArray[3] < TIMESTAMP)
				continue;
			$quickinfo[$BuildArray[0]]	= $BuildArray[1];
			if ($PLANET['planet_type']==3){
				$dm_fast = floor(1000*($BuildArray[3]-TIMESTAMP)/3600);
			}
			else{
				$dm_fast = floor(200*($BuildArray[3]-TIMESTAMP)/3600);
			}
			$scriptData[$BuildArray[0]] = array(
				'element'	=> $BuildArray[0], 
				'level' 	=> $BuildArray[1], 
				'time' 		=> $BuildArray[2], 
				'resttime' 	=> ($BuildArray[3] - TIMESTAMP), 
				'destroy' 	=> ($BuildArray[4] == 'destroy'), 
				'endtime' 	=> _date('U', $BuildArray[3], $USER['timezone']),
				'display' 	=> _date($LNG['php_tdformat'], $BuildArray[3], $USER['timezone']),
				'need_dm' 	=> $dm_fast, 
			);
		}
		return array('queue' => $scriptData, 'quickinfo' => $quickinfo);
	}
​?>

if u use MOD build queue acceleration​

change

<?
	private function FastBuildingFromQueue()
	{
	...
	}
​?>

to

<?
	private function FastBuildingFromQueue($Element)
	{
		global $PLANET, $USER, $resource;	
		$CurrentQueue  = unserialize($PLANET['b_building_id']);	
		if (empty($CurrentQueue)){
			$PLANET['b_building_id']	= '';
			$PLANET['b_building']		= 0;
			return;		
		}
		$uKey = -1;
		foreach($CurrentQueue as $key => $QueueElem){
			if($Element == $QueueElem[0])
				$uKey = $key;
		}
		if($uKey == -1)
			return false;
​
		$Element             	= $CurrentQueue[$uKey][0];
		$BuildMode          	= $CurrentQueue[$uKey][4];
		$fast                   = $resource[$Element];
		$BuildEndTime 			= $CurrentQueue[$uKey][3];
		if ($PLANET['planet_type']==3){  
            $NeededDm           = (1000*(($BuildEndTime-TIMESTAMP)/3600));
		}else{ 
			$NeededDm           = (200*(($BuildEndTime-TIMESTAMP)/3600));
		}
		if($NeededDm < 10)
			$NeededDm=10;
        if ($USER['darkmatter'] >= $NeededDm){
			$USER['darkmatter']		        -= $NeededDm;
			if ($BuildMode == 'destroy'){
				$PLANET['field_current'] -=1;
				$PLANET[$resource[$Element]] -= 1;
				$sql = "UPDATE %%PLANETS%% SET ".$fast." = ".$fast." - 1 WHERE id = :planetId;";
			}
			else{
				$PLANET['field_current'] +=1;
				$PLANET[$resource[$Element]] += 1;
				$sql = "UPDATE %%PLANETS%% SET ".$fast." = ".$fast." + 1 WHERE id = :planetId;";
			}
			Database::get()->update($sql, array(':planetId'	=> $PLANET['id']));
			unset($CurrentQueue[$uKey]);
			if (count($CurrentQueue) == 0) {
				$PLANET['b_building']    	= 0;
				$PLANET['b_building_id'] 	= '';
			} else {
				$NewQueueArray	= array();
				$b_building = 0;
				foreach($CurrentQueue as $ListIDArray) {
					$NewQueueArray[]	= $ListIDArray;	
​
					$BuildEndTime 	= $ListIDArray[3];
					if ($BuildEndTime > TIMESTAMP){
						if($b_building == 0)
							$b_building = $BuildEndTime;
						elseif($b_building > $BuildEndTime)
							$b_building = $BuildEndTime;
					}
				}
				if(!empty($NewQueueArray)) {
					$PLANET['b_building']    	= $b_building;
					$PLANET['b_building_id'] 	= serialize($NewQueueArray);
					$this->ecoObj->setData($USER, $PLANET);
					list($USER, $PLANET)		= $this->ecoObj->getData();
				} else {
					$PLANET['b_building']    	= 0;
					$PLANET['b_building_id'] 	= '';
				}
			}
			 return true;
		}
	}
​?>

change​

<?
	$this->CancelBuildingFromQueue();
​?>

to

<?
	$this->CancelBuildingFromQueue($Element);
​?>

if u use MOD build queue acceleration​

<?
	$this->FastBuildingFromQueue();
​?>

to

<?
	$this->FastBuildingFromQueue($Element);
?>